#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gnome.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <glib.h>
#include <gtkgl/gtkglarea.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <unistd.h>
#include "dirs.h"
#include "draw.h"
#include "behavior.h"



void stuffHappenned (GtkWidget * widget, GdkEvent * event, gpointer user_data) {
	//g_print ("a button was pressed");
	switch (event->type) {
		case GDK_BUTTON_PRESS:
			button (event);
			break;
		case GDK_BUTTON_RELEASE:
			button (event);
			break;
		case GDK_MOTION_NOTIFY:
			motion (event);
		default:
			break;
	}
}

void button (GdkEvent * event) {
}

void keys(GtkWidget * widget, GdkEvent * event, gpointer user_data) {
	//g_print("a key was pressed");
	switch (event->type) {
		case GDK_DELETE:
		case GDK_DESTROY:
			gtk_main_quit();
			break;
		case GDK_CONFIGURE:
			if (gtk_gl_area_make_current(GTK_GL_AREA(widget))) {
		                glViewport(0,0,widget->allocation.width, widget->allocation.height);
			}
			break;
		case GDK_KEY_PRESS:
			keyDown(event);
			break;
		case GDK_KEY_RELEASE:
			keyUp(event);
			break;
		default:
			break;
	}
}

void keyDown(GdkEvent * event) {
	char * temp, *temp1, *temp2;
	int tp;
	switch (((GdkEventKey *) event)-> string[0]) {
		case 'd':
			strafeX -= 0.2;
			break;
		case 'a':
			strafeX += 0.2;
			break;
		case 'w':
			strafeY += 0.2;
			break;
		case 's':
			strafeY -= 0.2;
			break;
		case 'e':
			strafeZ += 0.5;
			break;
		case 'r':
			strafeZ -= 0.5;
			break;
		case '\t':
			pFiles = g_list_first(pFiles);
			if (((pFile *) g_list_last(pFiles)->data)->selected) {
				((pFile *) g_list_first(pFiles)->data)->selected = TRUE;
				((pFile *) g_list_last(pFiles)->data)->selected = FALSE;
				selected = (pFile *) g_list_first(pFiles)->data;
			} else {
				while (g_list_next(pFiles) != NULL) {
					if (((pFile *) pFiles->data)->selected) {
						((pFile *) (g_list_next(pFiles)->data))->selected = TRUE;
						((pFile *) pFiles->data)->selected = FALSE;
						selected = (pFile *) (g_list_next(pFiles)->data) ;
						break;
					}
					pFiles = g_list_next(pFiles);
				}
			}
			break;
		case 'q':
			pFiles = g_list_last(pFiles);
			if (((pFile *) g_list_first(pFiles)->data)->selected) {
				((pFile *) g_list_last(pFiles)->data)->selected = TRUE;
				((pFile *) g_list_first(pFiles)->data)->selected = FALSE;
				selected = (pFile *) g_list_last(pFiles)->data;
			} else {
				while (g_list_previous(pFiles) != NULL) {
					if (((pFile *) pFiles->data)->selected) {
						((pFile *) (g_list_previous(pFiles)->data))->selected = TRUE;
						((pFile *) pFiles->data)->selected = FALSE;
						selected = (pFile *) (g_list_previous(pFiles)->data) ;
						break;
					}
					pFiles = g_list_previous(pFiles);
				}
			}
			break;
		case 'f':
		case ' ':
			if (S_ISDIR(selected->data.st_mode)) {
				temp = malloc (sizeof (char) * (strlen(selected->nameTotal) + 1));
				strcpy(temp, selected->nameTotal);
				moveToDir(temp);
			} else {
				temp2 = gnome_mime_type_of_file(selected->nameTotal);
				temp1 = gnome_mime_program(temp2);
				if (temp1 == NULL) {
					break;
				}
				temp = malloc (sizeof (char) * (strlen (selected->nameTotal) + strlen (temp1) + 2));
				temp = strcpy (temp, temp1);
				tp = strlen (temp1);
				temp[tp] = ' ';
				temp += (tp + 1);
				temp  = strcpy (temp, selected->nameTotal);
				temp -= (tp + 1);
				gnome_execute_shell ("/", temp);
				//g_print ("wazzup");
			}
		default:
			//g_print("%s", ((GdkEventKey *) event)->string);
			break;
	}
}

void keyUp(GdkEvent * event) {
}

void motion (GdkEvent * event) {
	//strafeX += ((GdkEventMotion *) event)->x;
	//strafeY += ((GdkEventMotion *) event)->y;
}
