//objects
char *username;
char *homedir; //home directory
char *current; //current directory
GList * dirHistory;//history of directories
GList * pFiles;//files which must be rendered
//functions: mainly string manipulation
void moveToNext();
void moveToPrev();
void moveUp();
void moveToHome();
void moveToDir(char * dir);
//MimeTypes
enum mime { PL, TXT, DOC, C, CPP, EL, ZIP, JPG, BLAH };
enum view { VIEW2D, VIEW3D, FANCY };
enum display { SHOWALL, HIDE };
enum icon { PRETTY, JULIA };  //It's a binary situation
enum display displayMode;
enum icon iconMode;
//data structures
struct _PIMPFILE {
	char * name;
	char * nameTotal;
	struct stat data;
	enum mime filetype ;  //use stat to set, and macros to read.
	float x; /*for dragging*/
	float y;
	float z;
	double angle; /*for selection spinning*/
	int selected;
	int copied;
	int AllGood;
};

typedef struct _PIMPFILE pFile;
pFile * selected;
//funcion
void killPFiles();
void makePFiles();
int makeHelper(struct direct * dir);
pFile * makePFile(char * file, int x, int y, int z);
void repositionFiles();
enum mime grabFT(char * file);
void nextPos (int * x, int* y, int* z, enum view dim);
