
//objects
GtkWidget *glarea;
//GtkWidget *box;
//functions
void spawnNewWindow();
void openNewDir();
void closeThisWindow();
void exitProgram();
void moveFoward();
void moveBackward();
void moveUpward();
void goHomeward();
void search();
void showBooring();
void CloseTheApp (GtkWidget * window, gpointer data);
void helpAbout();
gint initializeArea (GtkWidget *widget);
gint draw(GtkWidget *widget, GdkEventExpose *event);
gint reshape (GtkWidget *widget, GdkEventConfigure *event);
void addNewFile();//creates a new file in current directory
void cutFunc();
void copyFunc();
void pasteFunc();
void set3d();
void set2d();
void hide();
void show();
void iconned();
void julia();//with no pixmapping "flat"
gint redrawWindow(void);
//cut and paste stuff
int cutP, copyP;
char * cutItem, * cutShort;
char * copyItem, * copyShort;

//menus
//top menu
static GnomeUIInfo file_menu[] = {
	GNOMEUIINFO_MENU_NEW_ITEM ("New", "new window", spawnNewWindow, NULL),
	GNOMEUIINFO_MENU_OPEN_ITEM (openNewDir, NULL),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_CLOSE_ITEM(closeThisWindow, NULL),
	GNOMEUIINFO_MENU_EXIT_ITEM(exitProgram, NULL),
	GNOMEUIINFO_END
};

//navigation buttons
static GnomeUIInfo navigation_menu[] = {
	{GNOME_APP_UI_ITEM, "forward", "move forward", moveFoward, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_FORWARD, 0, 0, NULL},
	{GNOME_APP_UI_ITEM, "back", "move back", moveBackward, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BACK, 0, 0, NULL},
	{GNOME_APP_UI_ITEM, "up", "move up", moveUpward, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_UP, 0, 0, NULL},
	{GNOME_APP_UI_ITEM, "home", "go home, steve", goHomeward, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_HOME, 0, 0, NULL},
	{GNOME_APP_UI_ITEM, "new", "open new window", addNewFile, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_NEW, 0, 0, NULL},
	GNOMEUIINFO_END
};
//view sub-menu
static GnomeUIInfo view_radios[] = {
	GNOMEUIINFO_RADIOITEM( "view 3d", "see the world in 3d", set3d, NULL),
	GNOMEUIINFO_RADIOITEM( "view 2d", "see the world in 2d", set2d, NULL),
	GNOMEUIINFO_END
};
//show sub-menu
static GnomeUIInfo display_radios[] = {
	GNOMEUIINFO_RADIOITEM( "hide hidden", "display hidden files", hide, NULL),
	GNOMEUIINFO_RADIOITEM( "show all", "display all hidden files", show, NULL),
	GNOMEUIINFO_END
};
static GnomeUIInfo icon_radios[] = {
	GNOMEUIINFO_RADIOITEM( "pretty Icons", "pixmaps on icons", iconned, NULL),
	GNOMEUIINFO_RADIOITEM( "basic icons", "hide pixmaps", julia, NULL),
	GNOMEUIINFO_END
};
//choose view
static GnomeUIInfo view_menu[] = {
	GNOMEUIINFO_RADIOLIST(view_radios),
	GNOMEUIINFO_RADIOLIST(display_radios),
	GNOMEUIINFO_RADIOLIST(icon_radios),
	GNOMEUIINFO_END
};
//editing capabilities
static GnomeUIInfo edit_menu[] = {
	GNOMEUIINFO_MENU_CUT_ITEM(cutFunc, NULL),
	GNOMEUIINFO_MENU_COPY_ITEM(copyFunc, NULL),
	GNOMEUIINFO_MENU_PASTE_ITEM(pasteFunc, NULL),
	GNOMEUIINFO_END
};
//help menu
static GnomeUIInfo help_menu[] = {
	GNOMEUIINFO_HELP("stdmain"),
	GNOMEUIINFO_MENU_ABOUT_ITEM(helpAbout, NULL),
	GNOMEUIINFO_END
};
//main menu
static GnomeUIInfo main_menu[] = {
	GNOMEUIINFO_MENU_FILE_TREE (file_menu),
	GNOMEUIINFO_SUBTREE("_View", view_menu),
	GNOMEUIINFO_SUBTREE("_Edit", edit_menu),
	GNOMEUIINFO_SUBTREE("_Help", help_menu),
	GNOMEUIINFO_END
};

int attrlist[] = {
	GDK_GL_RGBA,
	GDK_GL_RED_SIZE,1,
	GDK_GL_GREEN_SIZE,1,
	GDK_GL_BLUE_SIZE,1,
	GDK_GL_DOUBLEBUFFER,
	GDK_GL_NONE
};
